//Martin Rheinländer, SS 05

#include"List.h"


template<class T>
List<T>::List(){
	Bot = new ListElement<T>;
	Top = new ListElement<T>;
	Bot->Next = Top;
	Top->Prev = Bot;
	Bot->Prev = 0;
	Top->Next = 0; 
	First = Bot;
	Last  = Top;
	Counter = 0;
}

template<class T>
List<T>::~List(){
        if(Counter==0) delete Bot;
        else{ 
		ListElement<T>* Current = First;
		for(int i=0; i<=Counter; i++){ 
			delete Current->Prev;
			Current = Current->Next; 
		}	
	}
	delete Top;      
}

template<class T>
void List<T>::emptyout(){
	if(Counter>0){
		ListElement<T>* Current = First;
		for(int i=0; i<=Counter; i++){ 
			delete Current->Prev;
			Current = Current->Next; 
		}
		delete Top;
	
		Bot = new ListElement<T>;
		Top = new ListElement<T>;
		Bot->Next = Top;
		Top->Prev = Bot;
		Bot->Prev = 0;
		Top->Next = 0; 
		First = Bot;
		Last  = Top;
		Counter = 0;
	}
}

template<class T>    
void List<T>::prepend(const T& Input){
	ListElement<T>* newElement = new ListElement<T>;
	newElement->Data  = Input;
	if(Counter==0){
		newElement->Next = Top;
		newElement->Prev = Bot; 
		Bot->Next = newElement;
		Top->Prev = newElement;
		First     = newElement;
		Last      = newElement;
	}else{
		newElement->Next  = First;
		newElement->Prev  = Bot;
		Bot  ->Next       = newElement;
		First->Prev       = newElement; 
		First             = newElement;
	}	
	Counter++; 
}

template<class T>    
void List<T>::append(const T& Input){
	ListElement<T>* newElement = new ListElement<T>;
	newElement->Data = Input;
	if(Counter==0){
		newElement->Next = Top;
		newElement->Prev = Bot; 
		Bot->Next = newElement;
		Top->Prev = newElement;
		First     = newElement;
		Last      = newElement; 
	}else{
		newElement->Next = Top;
		newElement->Prev = Last;
		Top ->Prev       = newElement;
		Last->Next       = newElement;
		Last             = newElement;
	}	
	Counter++; 
}

template<class T>
void List<T>::insertBotMost(int n,const T& Input){
	if(n<0 || n>Counter)
		{std::cerr<<"List<T>::insertBotMost: argument is out of range."<<std::endl; exit(1);}
	
	ListElement<T>* newElement = new ListElement<T>;
	ListElement<T>* Current    = First;
	newElement->Data           = Input;

	if(Counter==0){
		newElement->Next = Top;
		newElement->Prev = Bot; 
		Bot->Next = newElement;
		Top->Prev = newElement;
		First     = newElement;
		Last      = newElement; 
	}else{	
		for(int i=0; i<n; i++) Current = Current->Next; 
        	//insert between Current->Prev and Current
		newElement->Prev    = Current->Prev;
		newElement->Next    = Current;
		Current->Prev->Next = newElement;
		Current->Prev       = newElement;
	}
	if(n==0)         First = newElement;
	if(n==Counter-1) Last  = newElement;	
	Counter++;
}

template<class T>
void List<T>::insertTopMost(int n,const T& Input){
	if(n<0 || n>Counter)
		{std::cerr<<"List<T>::insertTopMost: argument is out of range."<<std::endl; exit(1);}
	
	ListElement<T>* newElement = new ListElement<T>;
	ListElement<T>* Current    = Last;
	newElement->Data           = Input;

	if(Counter==0){
		newElement->Next = Top;
		newElement->Prev = Bot; 
		Bot->Next = newElement;
		Top->Prev = newElement;
		First     = newElement;
		Last      = newElement; 
	}else{		
		for(int i=0; i<n; i++) Current = Current->Prev; 
                //insert between Current and Current->Next
                newElement->Prev    = Current;
		newElement->Next    = Current->Next;
		Current->Next->Prev = newElement;
		Current->Next       = newElement;
	}
	if(n==0)         Last   = newElement;
	if(n==Counter-1) First  = newElement;	
	Counter++;
}		       
   


template<class T>
T List<T>::eraseBotMost(int n){
	if(n<0 || n>=Counter)
		{std::cerr<<"List<T>::erase: argument is out of range."<<std::endl; exit(1);}
		
        ListElement<T>* Current = First;
	for(int i=0; i<n; i++) Current = Current->Next;
		
	if     (Counter==1    ){First = Bot; Last = Top;}
	else if(Current==First) First = Current->Next;
	else if(Current==Last ) Last  = Current->Prev;
	Current->Next->Prev = Current->Prev;
	Current->Prev->Next = Current->Next;
		
	T Output =  Current->Data;
	delete Current; Counter--; 
	return Output;
}

template<class T>
T List<T>::eraseTopMost(int n){
	if(n<0 || n>=Counter)
		{std::cerr<<"List<T>::eraseTopMost: argument is out of range."<<std::endl; exit(1);}
		
        ListElement<T>* Current = Last;
	for(int i=0; i<n; i++) Current = Current->Prev;
		
	if     (Counter==1    ){First = Bot; Last = Top;}
	else if(Current==First) First = Current->Next;
	else if(Current==Last ) Last  = Current->Prev;
	Current->Next->Prev = Current->Prev;
	Current->Prev->Next = Current->Next;
		
	T Output =  Current->Data;
	delete Current; Counter--; 
	return Output;
}






template<class T>
T& List<T>::operator()(int n){
	if(n<0 || n>=Counter)
		{std::cerr<<"List<T>::operator(): argument is out of range."<<std::endl; exit(1);}
	
	ListElement<T>* Current = First;
	for(int i=0; i<n; i++) Current = Current->Next;
	return Current->Data;
}

template<class T>
T& List<T>::getBotMost(int n){
	if(n<0 || n>=Counter)
		{std::cerr<<"List<T>::getBotMost: argument is out of range."<<std::endl; exit(1);}
	
	ListElement<T>* Current = First;
	for(int i=0; i<n; i++) Current = Current->Next;
	return Current->Data;
}

template<class T>
T& List<T>::getTopMost(int n){
	if(n<0 || n>=Counter)
		{std::cerr<<"List<T>::getTopMost: argument is out of range."<<std::endl; exit(1);}
	
	ListElement<T>* Current = Last;
	for(int i=0; i<n; i++) Current = Current->Prev;
	return Current->Data;
}



template<class T>
void List<T>::print(){
   ListElement<T>* Current = First;
   for(int i=0; i<Counter; i++){
   	 std::cout << Current->Data << " ";
	 Current = Current->Next;
   }	 
   std::cout<<std::endl;
}


template<class Type>
void my_swap(Type& a,Type& b){
	Type c; c=a; a=b; b=c;
}


template<class T>
int* List<T>::sort(){
        if(Counter<2) return NULL;        

	int* Temp = new int[Counter];
	int* Perm = new int[Counter];
	T Least;
  
	for(int i=0; i<Counter; i++) Temp[i]=i;
	for(int i=0; i<Counter; i++){
	        int k = i;
		Least = (*this)(i); 
		for(int j=i; j<Counter; j++) 
			if((*this)(j) < Least){Least = (*this)(j); k=j;}
		my_swap((*this)(i),(*this)(k));
		my_swap(Temp[i],Temp[k]);
	}//for
	for(int i=0; i<Counter; i++) Perm[Temp[i]] = i;
	delete [] Temp;  return Perm;
}//select_sort
