//Martin Rheinländer, SS 05

#ifndef MWDRAWAREA_H
#define MWDRAWAREA_H

#include <qevent.h>
#include <qpoint.h>
#include <qwidget.h>
#include <qpainter.h>

#include <math.h>
#include <iostream>
#include "List.h"
#include "MWPoint.h"

class QPaintEvent;
class QMouseEvent;


class MWDrawArea: public QWidget{
	Q_OBJECT
public:
	MWDrawArea( QWidget *parent=0, const char *name=0);
	virtual ~MWDrawArea();
	
	void setDrawMode(int);
	void setPointSize(int);
	void setGridSnap(bool);
	void setCoordRange(double x_min, double x_max, double y_min, double y_max);
	void setGridSpacing(double dx_, double dy_);
	void clearConvexHull();
	void undo();
	
	QPoint  getPixel (const MWPoint&);
	int     getPixelX(const MWPoint&);
	int     getPixelY(const MWPoint&);
	MWPoint getCoord (const QPoint&);
	
	void findConvexHull();
	void constructConvexHull();
protected:
	void paintEvent(QPaintEvent*);
	void mouseReleaseEvent(QMouseEvent*);
	void keyPressEvent(QKeyEvent*);	
private:
	int      DrawMode;
	int     PointSize; 
	bool   GridSnapON;
	
	List<MWPoint> PointCloud;
	List<MWPoint> ConvexHull;
	List<MWPoint> UpperConvexHull;
	List<MWPoint> LowerConvexHull;
	int currentIndex;
	
	double xmin, xmax, ymin, ymax;
	double dx, dy;
	double sx, sy;
};
#endif // MWDRAWAREA_H

