//Martin Rheinländer, SS 05
#include "MWPoint.h"

MWPoint& MWPoint::operator= (const MWPoint& V){x =V.x; y =V.y; return *this;}
MWPoint& MWPoint::operator+=(const MWPoint& V){x+=V.x; y+=V.y; return *this;}
MWPoint& MWPoint::operator-=(const MWPoint& V){x-=V.x; y-=V.y; return *this;}
MWPoint  MWPoint::operator+ (const MWPoint& V)const {MWPoint W; W.x=x+V.x; W.y=y+V.y; return W;}
MWPoint  MWPoint::operator- (const MWPoint& V)const {MWPoint W; W.x=x-V.x; W.y=y-V.y; return W;}
double   MWPoint::operator* (const MWPoint& V)const {return x*V.x + y*V.y;}
double&  MWPoint::operator[](int i){if(i==1) return x; else if(i==2) return y; else exit(1);}

bool MWPoint::operator< (const MWPoint& V)const{
	if(x==V.x)
		if(y<V.y) return true;
		else return false;
	else if(x < V.x) return true;
	else return false;	
}

double Det (const MWPoint& V, const MWPoint& W){return V.x*W.y - V.y*W.x;}
double Norm(const MWPoint& V){return sqrt(V.x*V.x + V.y*V.y);}

MWPoint getMWPoint(double x_init, double y_init){
	MWPoint V(x_init,y_init); return V;
}

std::ostream& operator<< (std::ostream& output, const MWPoint& V){
	output.setf(std::ios::right | std::ios::showpos | std::ios::fixed);
	output.precision(4);
	output.width(14);
	output << "x = "<<V.x;
	output.width(14);
	output << "y = "<<V.y << std::endl;
	return output;
}

bool isStrictLeftTurn(const MWPoint& A, const MWPoint& B, const MWPoint& C){
	//C should be strictly at the left hand side of the line directed from A to B
	if(Det(A-C,B-C)>0.0) return true;
	else return false; 
}

bool isStrictRightTurn(const MWPoint& A, const MWPoint& B, const MWPoint& C){
	//C should be strictly at the right hand side of the line directed from A to B
	if(Det(A-C,B-C)<0.0) return true;
	else return false; 
}


