//Martin Rheinländer, SS 05

#ifndef MWPOINT_H
#define MWPOINT_H

#include<math.h>
#include<ostream>
#include<iomanip>

class MWPoint{
public:
	MWPoint(): x(0.0), y(0.0) {};
	MWPoint(double x_init, double y_init): x(x_init), y(y_init) {};
       ~MWPoint(){};	
	
	MWPoint& operator= (const MWPoint&);
	MWPoint& operator+=(const MWPoint&);
	MWPoint& operator-=(const MWPoint&);
	MWPoint  operator+ (const MWPoint&) const;
	MWPoint  operator- (const MWPoint&) const;
	double   operator* (const MWPoint&) const;
	double&  operator [](int i);
	bool   operator <(const MWPoint&) const;
	double getx()const {return x;};
	double gety()const {return y;};
  
	friend double  Det  (const MWPoint&, const MWPoint&);
	friend double  Norm (const MWPoint&);
	friend MWPoint getMWPoint(double,double);
	friend std::ostream& operator<<(std::ostream&, const MWPoint&);
	friend bool isStrictLeftTurn (const MWPoint&, const MWPoint&, const MWPoint&);
	friend bool isStrictRightTurn(const MWPoint&, const MWPoint&, const MWPoint&);
protected:
	double x,y;
};

#endif // MWPOINT_H
